﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WpfApplicationHaltestellen
{
    struct GeoPunkt
    {
        double lon;
        public double Lon
        { get { return lon; } }

        double lat;
        public double Lat
        { get { return lat; } }

        public GeoPunkt(double lon, double lat)
        {
            this.lon = lon;
            this.lat = lat;
        }

        const double radius = 6371.0; //km

        static double bogen(double winkelInGrad)
        {
            return winkelInGrad / 180.0 * Math.PI;
        }

        public double X
        { get { return radius * Math.Cos(bogen(Lat)) * Math.Cos(bogen(Lon)); } }

        public double Y
        { get { return radius * Math.Cos(bogen(Lat)) * Math.Sin(bogen(Lon)); } }

        public double Z
        { get { return radius * Math.Sin(bogen(Lat)); } }

        static public double BestimmeAbstand(GeoPunkt p1, GeoPunkt p2)
        {
            double skalarprodukt = p1.X * p2.X + p1.Y * p2.Y + p1.Z * p2.Z;
            return radius * Math.Acos(skalarprodukt / (radius * radius));
        }
    }
}
